/*******************************************************************************
 * I9 TECHNOLOGIES CONFIDENTIAL
 * __________________
 * Copyright © 2013 i9 Technologies 
 * All Rights Reserved.
 * 
 * NOTICE:  All information contained herein is, and remains the property 
 * of i9 Technologies and its suppliers, if any.  The intellectual and technical 
 * concepts contained herein are proprietary to i9 Technologies and its 
 * suppliers and may be covered by U.S. and Foreign Patents, patents in 
 * process, and are protected by trade secret or copyright law. Dissemination 
 * of this information or reproduction of this material is strictly forbidden 
 * unless prior written permission is obtained from i9 Technologies.
 ******************************************************************************/
package com.xmlnamespace.panel.vaadin.ui;

import com.vaadin.ui.AbstractComponent;
import com.xmlnamespace.panel.vaadin.shared.ui.HorizontalMarqueeState;

/**
 * HorizontalMarquee Widget.
 */
public class HorizontalMarquee extends AbstractComponent {

    /** The Constant serialVersionUID. */
    private static final long serialVersionUID = -6484207618140041824L;

    /**
     * Sets the scroll.
     * 
     * @param scroll
     *            the new scroll
     */
    public void setScroll(boolean scroll) {
        getState().scroll = scroll;
        markAsDirty();
    }

    /**
     * Checks if is scroll.
     * 
     * @return true, if is scroll
     */
    public boolean isScroll() {
        return getState().scroll;
    }

    /**
     * Sets the scroll on mouse over.
     * 
     * @param scrollOnMouseOver
     *            the new scroll on mouse over
     */
    public void setScrollOnMouseOver(boolean scrollOnMouseOver) {
        getState().scrollOnMouseOver = scrollOnMouseOver;
        markAsDirty();
    }

    /**
     * Checks if is scroll on mouse over.
     * 
     * @return true, if is scroll on mouse over
     */
    public boolean isScrollOnMouseOver() {
        return getState().scrollOnMouseOver;
    }

    /**
     * Sets the text.
     * 
     * @param text
     *            the new text
     */
    public void setText(String text) {
        getState().text = text;
        markAsDirty();
    }

    /**
     * Gets the text.
     * 
     * @return the text
     */
    public String getText() {
        return getState().text;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.vaadin.ui.Label#getState()
     */
    @Override
    protected HorizontalMarqueeState getState() {
        return (HorizontalMarqueeState) super.getState();
    }

}
